
import java.io.File;
import java.rmi.*;
import java.rmi.server.*;
import java.sql.*;
public class Student3TierImpl extends UnicastRemoteObject implements StudentServerInterface {
	static final long serialVersionUID = 1;
	
	// Use prepared statement for querying DB private 
	PreparedStatement pstmt;
	/** Constructs Student3TierImpl object and exports it on
	 * default port.
	 */
	public Student3TierImpl() throws RemoteException { 
		initializeDB();
	
	}
	
	/** Constructs Student3TierImpl object and exports it on
	 * specified port.
	 * @param port The port for exporting
	 */
	public Student3TierImpl(int port) throws RemoteException { super(port);
		initializeDB();
	}
	
	/** Load JDBC driver, establish connection and
	  create statement */
	protected void initializeDB() { 
		try {
			// Load the JDBC driver
			// Class.forName("oracle.jdbc.driver.OracleDriver"); 
			//Class.forName("sun.jdbc.odbc.JdbcOdbcDriver"); 
			Class.forName("org.sqlite.JDBC"); 
			System.out.println("Driver registered");
			// Establish connection
			/*Connection conn = DriverManager.getConnection
	      		("jdbc:oracle:thin:@drake.armstrong.edu:1521:orcl",
	        	"scott", "tiger");  */
			//Connection conn = DriverManager.getConnection("jdbc:odbc:exampleMDBDataSource", "", "" );
		     File f = new File("database.db");
		      if(f.exists())
		    	  f.delete();
		      
		      Connection conn = DriverManager.getConnection ("jdbc:sqlite:database.db");
		      System.out.println("Database connected");
		      // Create a statement
		      Statement stmt = conn.createStatement();
		      

		      //then use the statement as you wish to create schema (table upon application enquires), 

		      stmt.executeUpdate( "create table Scores (name varchar(20), score number, permission number);" );
		      stmt.executeUpdate( "insert into Scores values ('John', 90.5, 1);" );
		      stmt.executeUpdate( "insert into Scores values ('Michael', 90, 1);" );
		      stmt.executeUpdate( "insert into Scores values ('Michelle', 100, 0);" );

	 
			// Create a prepared statement for querying DB
			pstmt = conn.prepareStatement("select * from Scores where name = ?");
		}
		catch (Exception ex) {
			System.out.println(ex);
		}
	}
	
	public double findScore(String name) throws RemoteException { 
		double score = -1;
		try {
			// Set the specified name in the prepared statement
			pstmt.setString(1, name);
			// Execute the prepared statement execute SQL 
			ResultSet rs = pstmt.executeQuery();
			// Retrieve the score
			if (rs.next()) {
				if (rs.getBoolean(3))
					score = rs.getDouble(2);
			}
		}
		catch (SQLException ex) {
			 ex.printStackTrace();
		}
		System.out.println(name + "\'s score is " + score);
		return score;			
	}

}

