import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.ArrayList;
import java.util.UUID;


public class ServerImplementation extends UnicastRemoteObject implements ServerInterface {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static int usersCount;
	private ArrayList<String> usersNames;
	private ArrayList<CallBack> users;
	
	protected ServerImplementation() throws RemoteException {
		super();
		// TODO Auto-generated constructor stub
		usersNames = new ArrayList<String> ();
		users = new ArrayList<CallBack> ();
	}

	@Override
	public void login(CallBack client, String name) throws RemoteException {
		// TODO Auto-generated method stub
		usersCount ++;
		usersNames.add(name);
		users.add(client);
		System.out.println (name + " logged in ");
		for (int i = 0; i < users.size();i++)
			users.get(i).message(name + " logged in ");
		
	}

	@Override
	public void message(String name, String message) throws RemoteException {
		// TODO Auto-generated method stub
		System.out.println (name + " says: " + message);
		for (int i = 0; i < users.size();i++)
			users.get(i).message(name + " says: " + message);
	}

	@Override
	public void logoff(UUID ID, String name) throws RemoteException {
		// TODO Auto-generated method stub
		usersCount --;
		System.out.println (name + " logged Off ");
		usersNames.remove(name);
		for (int i = 0; i < users.size();i++)
			if (users.get(i).getID() == ID) {
				users.remove(i);
				break;
			}
		for (int i = 0; i < users.size();i++)
			users.get(i).message(name + " logged Off ");
	}
	
	@Override
	public ArrayList<String> getUsersNames() throws RemoteException {
		// TODO Auto-generated method stub
		return usersNames;
	}

	public static void main (String[] args) {
		ServerInterface server;
		try {
			server = new ServerImplementation();
			UnicastRemoteObject.unexportObject(server, true);
			ServerInterface stub = (ServerInterface) UnicastRemoteObject.exportObject(server, 0);
			Registry registry = LocateRegistry.getRegistry();
			registry.rebind("ServerImplementation", stub);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


}
