import java.io.IOException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.ArrayList;
import java.util.NoSuchElementException;
import java.util.Scanner;


public class Client {
	static Scanner in;
	

	public static int getUserInput () {
		System.out.println ("Choose one of the following actions:");
		System.out.println ("1: to send a message.");
		System.out.println ("2: to ask server about other users.");
		System.out.println ("3: to logoff.");
		return in.nextInt();
	}
	public static void main (String[] args) {
		Registry registry;
		try {
			registry = LocateRegistry.getRegistry("localhost");
			ServerInterface server = (ServerInterface) registry.lookup("ServerImplementation");
			in = new Scanner(System.in);
			System.out.println ("Please Enter your name:");
			String myname = "annonymous";
			if(in.hasNext())
				myname = in.next();
			server.login(myname);
			int input = 0;
			while (input != 3) {
				input = getUserInput ();
				switch (input) {
					case 1: 
						System.out.println ("Please Enter your message:");
						String msg = in.next();
						msg = msg.concat(in.nextLine());
						server.message (myname, msg);
						break;
					case 2: 
						ArrayList<String> users = server.getUsersNames();
						System.out.println("Users Currently Connected are:");
						for (int i = 0; i< users.size();i++) {
							System.out.println(users.get(i));
						}
						break;
					case 3: 
						server.logoff(myname);
						break;
				}
			}
			in.close();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotBoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
