import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.ArrayList;


public class ServerImplementation extends UnicastRemoteObject implements ServerInterface {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static int usersCount;
	private ArrayList<String> usersNames;
	
	protected ServerImplementation() throws RemoteException {
		super();
		// TODO Auto-generated constructor stub
		usersNames = new ArrayList<String> ();
	}

	@Override
	public void login(String name) throws RemoteException {
		// TODO Auto-generated method stub
		usersCount ++;
		usersNames.add(name);
	}

	@Override
	public void message(String name, String message) throws RemoteException {
		// TODO Auto-generated method stub
		System.out.println (name + " says: " + message);
	}

	@Override
	public void logoff(String name) throws RemoteException {
		// TODO Auto-generated method stub
		usersCount --;
		usersNames.remove(name);
	}
	public static void main (String[] args) {
		ServerInterface server;
		try {
			server = new ServerImplementation();
			Registry registry = LocateRegistry.getRegistry();
			registry.rebind("ServerImplementation", server);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public ArrayList<String> getUsersNames() throws RemoteException {
		// TODO Auto-generated method stub
		return usersNames;
	}

}
